/////////////////////////////////////////////////////////////////////////
// $Id: data_xfer32.cc,v 1.21 2002/10/25 18:26:27 sshwarts Exp $
/////////////////////////////////////////////////////////////////////////
//
//  Copyright (C) 2001  MandrakeSoft S.A.
//
//    MandrakeSoft S.A.
//    43, rue d'Aboukir
//    75002 Paris - France
//    http://www.linux-mandrake.com/
//    http://www.mandrakesoft.com/
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA






#define NEED_CPU_REG_SHORTCUTS 1
#include "bochs.h"
#define LOG_THIS BX_CPU_THIS_PTR

  void
BX_CPU_C::XCHG_ERXEAX(bxInstruction_c *i)
{
  Bit32u temp32;
  Bit8u temp32_integrity;
  Expression *TempExpr[4];
  Expression *OpcExpr[4];

  temp32 = EAX;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	TempExpr[0] = MakeACopyOf(TheLabels.ReadSymbolicRegister(0, 0));
	TempExpr[1] = MakeACopyOf(TheLabels.ReadSymbolicRegister(0, 1));
	TempExpr[2] = MakeACopyOf(TheLabels.ReadSymbolicRegister(0, 2));
	TempExpr[3] = MakeACopyOf(TheLabels.ReadSymbolicRegister(0, 3));
	OpcExpr[0] = MakeACopyOf(TheLabels.ReadSymbolicRegister(i->opcodeReg(), 0));
	OpcExpr[1] = MakeACopyOf(TheLabels.ReadSymbolicRegister(i->opcodeReg(), 1));
	OpcExpr[2] = MakeACopyOf(TheLabels.ReadSymbolicRegister(i->opcodeReg(), 2));
	OpcExpr[3] = MakeACopyOf(TheLabels.ReadSymbolicRegister(i->opcodeReg(), 3));
  }
#endif

#if BX_SUPPORT_X86_64
  RAX = BX_CPU_THIS_PTR gen_reg[i->opcodeReg()].dword.erx;
  BX_CPU_THIS_PTR gen_reg[i->opcodeReg()].dword.erx = temp32;
#else
  EAX = BX_CPU_THIS_PTR gen_reg[i->opcodeReg()].dword.erx;
  BX_CPU_THIS_PTR gen_reg[i->opcodeReg()].dword.erx = temp32;
#endif
  temp32_integrity = EAX_INTEGRITY;
  //LVAL_EAX_INTEGRITY = BX_CPU_THIS_PTR gen_reg[i->opcodeReg()].reg_integrity;
  BX_WRITE_32BIT_REG_INTEGRITY(0, BX_CPU_THIS_PTR gen_reg[i->opcodeReg()].reg_integrity);
  //BX_CPU_THIS_PTR gen_reg[i->opcodeReg()].reg_integrity = temp32_integrity; //EAX_INTEGRITY;
  BX_WRITE_32BIT_REG_INTEGRITY(i->opcodeReg(), temp32_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	TheLabels.WriteSymbolicRegister(0, 0, OpcExpr[0]);
	TheLabels.WriteSymbolicRegister(0, 1, OpcExpr[1]);
	TheLabels.WriteSymbolicRegister(0, 2, OpcExpr[2]);
	TheLabels.WriteSymbolicRegister(0, 3, OpcExpr[3]);
	TheLabels.WriteSymbolicRegister(i->opcodeReg(), 0, TempExpr[0]);
	TheLabels.WriteSymbolicRegister(i->opcodeReg(), 1, TempExpr[1]);
	TheLabels.WriteSymbolicRegister(i->opcodeReg(), 2, TempExpr[2]);
	TheLabels.WriteSymbolicRegister(i->opcodeReg(), 3, TempExpr[3]);
  }
#endif
}

  void
BX_CPU_C::MOV_ERXId(bxInstruction_c *i)
{
#if BX_SUPPORT_X86_64
  BX_CPU_THIS_PTR gen_reg[i->opcodeReg()].rrx = i->Id();
#else
  BX_CPU_THIS_PTR gen_reg[i->opcodeReg()].dword.erx = i->Id();
  BX_CPU_THIS_PTR gen_reg[i->opcodeReg()].reg_integrity = 0xFF;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	TheLabels.WriteSymbolicRegister(i->opcodeReg(), 0, NULL);
	TheLabels.WriteSymbolicRegister(i->opcodeReg(), 1, NULL);
	TheLabels.WriteSymbolicRegister(i->opcodeReg(), 2, NULL);
	TheLabels.WriteSymbolicRegister(i->opcodeReg(), 3, NULL);
  }
#endif
#endif
}

  void
BX_CPU_C::MOV_EEdGd(bxInstruction_c *i)
{
  Bit32u op2_32;
  Bit8u op2_integrity;
  Expression *Op2Expr[4];

  op2_32 = BX_READ_32BIT_REG(i->nnn());
  op2_integrity = BX_READ_32BIT_INTEGRITY(i->nnn());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	Op2Expr[0] = TheLabels.ReadSymbolicRegister(i->nnn(), 0);
	Op2Expr[1] = TheLabels.ReadSymbolicRegister(i->nnn(), 1);
	Op2Expr[2] = TheLabels.ReadSymbolicRegister(i->nnn(), 2);
	Op2Expr[3] = TheLabels.ReadSymbolicRegister(i->nnn(), 3);
  }
#endif


  write_virtual_dword(i->seg(), RMAddr(i), &op2_32, &op2_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	write_virtual_expression(i->seg(), RMAddr(i), MakeACopyOf(Op2Expr[0]));
	write_virtual_expression(i->seg(), RMAddr(i) + 1, MakeACopyOf(Op2Expr[1]));
	write_virtual_expression(i->seg(), RMAddr(i) + 2, MakeACopyOf(Op2Expr[2]));
	write_virtual_expression(i->seg(), RMAddr(i) + 3, MakeACopyOf(Op2Expr[3]));
  }
#endif
}

  void
BX_CPU_C::MOV_EGdGd(bxInstruction_c *i)
{
  Bit32u op2_32;
  Bit8u op2_integrity;
  Expression *Op2Expr[4];

  op2_32 = BX_READ_32BIT_REG(i->nnn());
  op2_integrity = BX_READ_32BIT_INTEGRITY(i->nnn());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	Op2Expr[0] = TheLabels.ReadSymbolicRegister(i->nnn(), 0);
	Op2Expr[1] = TheLabels.ReadSymbolicRegister(i->nnn(), 1);
	Op2Expr[2] = TheLabels.ReadSymbolicRegister(i->nnn(), 2);
	Op2Expr[3] = TheLabels.ReadSymbolicRegister(i->nnn(), 3);
  }
#endif

  BX_WRITE_32BIT_REGZ(i->rm(), op2_32);
  //BX_WRITE_32BIT_REG_INTEGRITY(i->rm(), (BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl) ? op2_integrity : 0xFF);
  /*if ((i->rm() == 5) && op2_integrity != 0xFF)
  	printf("EIP right now is %08x\n", EIP);*/
  BX_WRITE_32BIT_REG_INTEGRITY(i->rm(), op2_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	TheLabels.WriteSymbolicRegister(i->rm(), 0, MakeACopyOf(Op2Expr[0]));
	TheLabels.WriteSymbolicRegister(i->rm(), 1, MakeACopyOf(Op2Expr[1]));
	TheLabels.WriteSymbolicRegister(i->rm(), 2, MakeACopyOf(Op2Expr[2]));
	TheLabels.WriteSymbolicRegister(i->rm(), 3, MakeACopyOf(Op2Expr[3]));
  }
#endif
}


  void
BX_CPU_C::MOV_GdEGd(bxInstruction_c *i)
{
  // 2nd modRM operand Ex, is known to be a general register Gd.
  Bit32u op2_32;
  Bit8u op2_integrity;
  Expression *Op2Expr[4];
  int nnn;

  op2_32 = BX_READ_32BIT_REG(i->rm());
  op2_integrity = BX_READ_32BIT_INTEGRITY(i->rm());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	Op2Expr[0] = TheLabels.ReadSymbolicRegister(i->rm(), 0);
	Op2Expr[1] = TheLabels.ReadSymbolicRegister(i->rm(), 1);
	Op2Expr[2] = TheLabels.ReadSymbolicRegister(i->rm(), 2);
	Op2Expr[3] = TheLabels.ReadSymbolicRegister(i->rm(), 3);
  }
#endif

  nnn = i->nnn();
  BX_WRITE_32BIT_REGZ(nnn, op2_32);
  BX_WRITE_32BIT_REG_INTEGRITY(nnn, op2_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	TheLabels.WriteSymbolicRegister(nnn, 0, MakeACopyOf(Op2Expr[0]));
	TheLabels.WriteSymbolicRegister(nnn, 1, MakeACopyOf(Op2Expr[1]));
	TheLabels.WriteSymbolicRegister(nnn, 2, MakeACopyOf(Op2Expr[2]));
	TheLabels.WriteSymbolicRegister(nnn, 3, MakeACopyOf(Op2Expr[3]));
  }
#endif
}

  void
BX_CPU_C::MOV_GdEEd(bxInstruction_c *i)
{
  // 2nd modRM operand Ex, is known to be a memory operand, Ed.
  Bit32u op2_32;
  Bit8u op2_integrity;
  Expression *Op2Expr[4];

  read_virtual_dword(i->seg(), RMAddr(i), &op2_32, &op2_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	read_virtual_expression(i->seg(), RMAddr(i), &(Op2Expr[0]));
  	read_virtual_expression(i->seg(), RMAddr(i) + 1, &(Op2Expr[1]));
  	read_virtual_expression(i->seg(), RMAddr(i) + 2, &(Op2Expr[2]));
  	read_virtual_expression(i->seg(), RMAddr(i) + 3, &(Op2Expr[3]));
  }
#endif
  BX_WRITE_32BIT_REGZ(i->nnn(), op2_32);
  //BX_WRITE_32BIT_REG_INTEGRITY(i->nnn(), (BX_CPU_THIS_PTR sregs[BX_SEG_REG_CS].selector.rpl) ? op2_integrity: 0xFF);
  BX_WRITE_32BIT_REG_INTEGRITY(i->nnn(), op2_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	TheLabels.WriteSymbolicRegister(i->nnn(), 0, MakeACopyOf(Op2Expr[0]));
	TheLabels.WriteSymbolicRegister(i->nnn(), 1, MakeACopyOf(Op2Expr[1]));
	TheLabels.WriteSymbolicRegister(i->nnn(), 2, MakeACopyOf(Op2Expr[2]));
	TheLabels.WriteSymbolicRegister(i->nnn(), 3, MakeACopyOf(Op2Expr[3]));
  }
#endif
  BX_CPU_THIS_PTR gen_reg_debug_info[i->nnn()] = RMAddr(i);
}

  void
BX_CPU_C::LEA_GdM(bxInstruction_c *i)
{
  if (i->modC0()) {
    BX_PANIC(("LEA_GvM: op2 is a register"));
    UndefinedOpcode(i);
    return;
    }

    /* write effective address of op2 in op1 */
    BX_WRITE_32BIT_REGZ(i->nnn(), RMAddr(i));
    BX_WRITE_32BIT_REG_INTEGRITY(i->nnn(), /*BX_CPU_THIS_PTR RMAddr_integrity*/ 0xFF);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	TheLabels.WriteSymbolicRegister(i->nnn(), 0, NULL);
	TheLabels.WriteSymbolicRegister(i->nnn(), 1, NULL);
	TheLabels.WriteSymbolicRegister(i->nnn(), 2, NULL);
	TheLabels.WriteSymbolicRegister(i->nnn(), 3, NULL);
  }
#endif
}


  void
BX_CPU_C::MOV_EAXOd(bxInstruction_c *i)
{
  Bit32u temp_32;
  bx_address addr;
  Bit8u temp_32_integrity;
  Expression *TempExpr[4];

  addr = i->Id();

  /* read from memory address */

  if (!BX_NULL_SEG_REG(i->seg())) {
    BX_CPU_THIS_PTR RMAddr_integrity = 0xFF;
    read_virtual_dword(i->seg(), addr, &temp_32, &temp_32_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	read_virtual_expression(i->seg(), addr, &(TempExpr[0]));
  	read_virtual_expression(i->seg(), addr + 1, &(TempExpr[1]));
  	read_virtual_expression(i->seg(), addr + 2, &(TempExpr[2]));
  	read_virtual_expression(i->seg(), addr + 3, &(TempExpr[3]));
  }
#endif
    /*if (addr != 0xFF)
    	temp_32_integrity = 0x00;*/
    }
  else {
    BX_CPU_THIS_PTR RMAddr_integrity = 0xFF;
    read_virtual_dword(BX_SEG_REG_DS, addr, &temp_32, &temp_32_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	read_virtual_expression(BX_SEG_REG_DS, addr, &(TempExpr[0]));
  	read_virtual_expression(BX_SEG_REG_DS, addr + 1, &(TempExpr[1]));
  	read_virtual_expression(BX_SEG_REG_DS, addr + 2, &(TempExpr[2]));
  	read_virtual_expression(BX_SEG_REG_DS, addr + 3, &(TempExpr[3]));
  }
#endif
    /*if (addr != 0xFF)
    	temp_32_integrity = 0x00;*/
    }

  /* write to register */
#if BX_SUPPORT_X86_64
  RAX = temp_32;
#else
  EAX = temp_32;
#endif
  //LVAL_EAX_INTEGRITY = temp_32_integrity;
  BX_WRITE_32BIT_REG_INTEGRITY(0, temp_32_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	TheLabels.WriteSymbolicRegister(0, 0, MakeACopyOf(TempExpr[0]));
	TheLabels.WriteSymbolicRegister(0, 1, MakeACopyOf(TempExpr[1]));
	TheLabels.WriteSymbolicRegister(0, 2, MakeACopyOf(TempExpr[2]));
	TheLabels.WriteSymbolicRegister(0, 3, MakeACopyOf(TempExpr[3]));
  }
#endif
  }


  void
BX_CPU_C::MOV_OdEAX(bxInstruction_c *i)
{
  Bit32u temp_32;
  bx_address addr;
  Bit8u temp_32_integrity;
  Expression *TempExpr[4];

  addr = i->Id();

  /* read from register */
  temp_32 = EAX;
  temp_32_integrity = EAX_INTEGRITY;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	TempExpr[0] = TheLabels.ReadSymbolicRegister(0, 0);
	TempExpr[1] = TheLabels.ReadSymbolicRegister(0, 1);
	TempExpr[2] = TheLabels.ReadSymbolicRegister(0, 2);
	TempExpr[3] = TheLabels.ReadSymbolicRegister(0, 3);
  }
#endif

  /* write to memory address */
  if (!BX_NULL_SEG_REG(i->seg())) {
    write_virtual_dword(i->seg(), addr, &temp_32, &temp_32_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	write_virtual_expression(i->seg(), addr, MakeACopyOf(TempExpr[0]));
  	write_virtual_expression(i->seg(), addr + 1, MakeACopyOf(TempExpr[1]));
  	write_virtual_expression(i->seg(), addr + 2, MakeACopyOf(TempExpr[2]));
  	write_virtual_expression(i->seg(), addr + 3, MakeACopyOf(TempExpr[3]));
  }
#endif
    }
  else {
    write_virtual_dword(BX_SEG_REG_DS, addr, &temp_32, &temp_32_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	write_virtual_expression(BX_SEG_REG_DS, addr, MakeACopyOf(TempExpr[0]));
  	write_virtual_expression(BX_SEG_REG_DS, addr + 1, MakeACopyOf(TempExpr[1]));
  	write_virtual_expression(BX_SEG_REG_DS, addr + 2, MakeACopyOf(TempExpr[2]));
  	write_virtual_expression(BX_SEG_REG_DS, addr + 3, MakeACopyOf(TempExpr[3]));
  }
#endif
    }
}



  void
BX_CPU_C::MOV_EdId(bxInstruction_c *i)
{
  Bit32u op2_32;
  Bit8u op2_integrity;

    op2_32 = i->Id();
    op2_integrity = 0xFF;

    /* now write sum back to destination */
    if (i->modC0()) {
      BX_WRITE_32BIT_REGZ(i->rm(), op2_32);
      BX_WRITE_32BIT_REG_INTEGRITY(i->rm(), op2_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	TheLabels.WriteSymbolicRegister(i->rm(), 0, NULL);
	TheLabels.WriteSymbolicRegister(i->rm(), 1, NULL);
	TheLabels.WriteSymbolicRegister(i->rm(), 2, NULL);
	TheLabels.WriteSymbolicRegister(i->rm(), 3, NULL);
  }
#endif
      }
    else {
      write_virtual_dword(i->seg(), RMAddr(i), &op2_32, &op2_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	write_virtual_expression(i->seg(), RMAddr(i), NULL);
  	write_virtual_expression(i->seg(), RMAddr(i) + 1, NULL);
  	write_virtual_expression(i->seg(), RMAddr(i) + 2, NULL);
  	write_virtual_expression(i->seg(), RMAddr(i) + 3, NULL);
  }
#endif
      }
}


  void
BX_CPU_C::MOVZX_GdEb(bxInstruction_c *i)
{
#if BX_CPU_LEVEL < 3
  BX_PANIC(("MOVZX_GvEb: not supported on < 386"));
#else
  Bit8u  op2_8;
  Bit8u op2_integrity;
  Expression *Op2Expr;

  if (i->modC0()) {
    op2_8 = BX_READ_8BIT_REGx(i->rm(),i->extend8bitL());
    op2_integrity = BX_READ_8BIT_INTEGRITY(i->rm());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	Op2Expr = TheLabels.ReadSymbolicRegister(i->rm() % 4, i->rm() < 4 ? 0 : 1);
  }
#endif
    }
  else {
    /* pointer, segment address pair */
    read_virtual_byte(i->seg(), RMAddr(i), &op2_8, &op2_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
    read_virtual_expression(i->seg(), RMAddr(i), &Op2Expr);
  }
#endif
    }

    /* zero extend byte op2 into dword op1 */
    BX_WRITE_32BIT_REGZ(i->nnn(), (Bit32u) op2_8);
    op2_integrity = low_water_mark(op2_integrity, op2_integrity, INTEG_BYTE, INTEG_BYTE);
    BX_WRITE_32BIT_REG_INTEGRITY(i->nnn(), op2_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Expression *QuadWrite;
	QuadWrite = (Expression *) new QuadExpression(Op2Expr, NULL, NULL, NULL);
	WriteSymbolicQuadRegister(i->nnn(), QuadWrite);
	
	//TheLabels.WriteSymbolicRegister(i->nnn(), 0, MakeACopyOf(Op2Expr));
	////TheLabels.WriteSymbolicRegister(i->nnn(), 0, NULL);
	//TheLabels.WriteSymbolicRegister(i->nnn(), 1, NULL);
	//TheLabels.WriteSymbolicRegister(i->nnn(), 2, NULL);
	//TheLabels.WriteSymbolicRegister(i->nnn(), 3, NULL);
  }
#endif
#endif /* BX_CPU_LEVEL < 3 */
}

  void
BX_CPU_C::MOVZX_GdEw(bxInstruction_c *i)
{
#if BX_CPU_LEVEL < 3
  BX_PANIC(("MOVZX_GvEw: not supported on < 386"));
#else
  Bit16u op2_16;
  Bit8u op2_integrity;
  Expression *Op2Expr[2];

  if (i->modC0()) {
    op2_16 = BX_READ_16BIT_REG(i->rm());
    op2_integrity = BX_READ_16BIT_INTEGRITY(i->rm());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op2Expr[0] = TheLabels.ReadSymbolicRegister(i->rm(), 0);
  	Op2Expr[1] = TheLabels.ReadSymbolicRegister(i->rm(), 1);
  }
#endif
    }
  else {
    /* pointer, segment address pair */
    read_virtual_word(i->seg(), RMAddr(i), &op2_16, &op2_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	read_virtual_expression(i->seg(), RMAddr(i), &(Op2Expr[0]));
  	read_virtual_expression(i->seg(), RMAddr(i) + 1, &(Op2Expr[1]));
  }
#endif
    }

    /* zero extend word op2 into dword op1 */
    op2_integrity = low_water_mark(op2_integrity, op2_integrity, INTEG_WORD, INTEG_WORD);
     BX_WRITE_32BIT_REGZ(i->nnn(), (Bit32u) op2_16);
     BX_WRITE_32BIT_REG_INTEGRITY(i->nnn(), op2_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	TheLabels.WriteSymbolicRegister(i->nnn(), 0, MakeACopyOf(Op2Expr[0]));
	TheLabels.WriteSymbolicRegister(i->nnn(), 1, MakeACopyOf(Op2Expr[1]));
	//TheLabels.WriteSymbolicRegister(i->nnn(), 0, NULL);
	//TheLabels.WriteSymbolicRegister(i->nnn(), 1, NULL);
	TheLabels.WriteSymbolicRegister(i->nnn(), 2, NULL);
	TheLabels.WriteSymbolicRegister(i->nnn(), 3, NULL);
  }
#endif
#endif /* BX_CPU_LEVEL < 3 */
}

  void
BX_CPU_C::MOVSX_GdEb(bxInstruction_c *i)
{
#if BX_CPU_LEVEL < 3
  BX_PANIC(("MOVSX_GvEb: not supported on < 386"));
#else
  Bit8u op2_8;
  Bit8u op2_integrity;
  Expression *Op2Expr;

  if (i->modC0()) {
    op2_8 = BX_READ_8BIT_REGx(i->rm(),i->extend8bitL());
    op2_integrity = BX_READ_8BIT_INTEGRITY(i->rm());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	Op2Expr = TheLabels.ReadSymbolicRegister(i->rm() % 4, i->rm() < 4 ? 0 : 1);
  }
#endif
    }
  else {
    /* pointer, segment address pair */
    read_virtual_byte(i->seg(), RMAddr(i), &op2_8, &op2_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
    read_virtual_expression(i->seg(), RMAddr(i), &Op2Expr);
  }
#endif
    }

    /* sign extend byte op2 into dword op1 */
    op2_integrity = low_water_mark(op2_integrity, op2_integrity, INTEG_BYTE, INTEG_BYTE);
    BX_WRITE_32BIT_REGZ(i->nnn(), (Bit8s) op2_8);
    BX_WRITE_32BIT_REG_INTEGRITY(i->nnn(), op2_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	TheLabels.WriteSymbolicRegister(i->nnn(), 0, MakeACopyOf(Op2Expr));
	TheLabels.WriteSymbolicRegister(i->nnn(), 1, NULL);
	TheLabels.WriteSymbolicRegister(i->nnn(), 2, NULL);
	TheLabels.WriteSymbolicRegister(i->nnn(), 3, NULL);
  }
#endif
#endif /* BX_CPU_LEVEL < 3 */
}

  void
BX_CPU_C::MOVSX_GdEw(bxInstruction_c *i)
{
#if BX_CPU_LEVEL < 3
  BX_PANIC(("MOVSX_GvEw: not supported on < 386"));
#else
  Bit16u op2_16;
  Bit8u op2_integrity;
  Expression *Op2Expr[2];

  if (i->modC0()) {
    op2_16 = BX_READ_16BIT_REG(i->rm());
    op2_integrity = BX_READ_16BIT_INTEGRITY(i->rm());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op2Expr[0] = TheLabels.ReadSymbolicRegister(i->rm(), 0);
  	Op2Expr[1] = TheLabels.ReadSymbolicRegister(i->rm(), 1);
  }
#endif
    }
  else {
    /* pointer, segment address pair */
    read_virtual_word(i->seg(), RMAddr(i), &op2_16, &op2_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	read_virtual_expression(i->seg(), RMAddr(i), &(Op2Expr[0]));
  	read_virtual_expression(i->seg(), RMAddr(i) + 1, &(Op2Expr[1]));
  }
#endif
    }

    /* sign extend word op2 into dword op1 */
    op2_integrity = low_water_mark(op2_integrity, op2_integrity, INTEG_WORD, INTEG_WORD);

    BX_WRITE_32BIT_REGZ(i->nnn(), (Bit16s) op2_16);
    BX_WRITE_32BIT_REG_INTEGRITY(i->nnn(), op2_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	TheLabels.WriteSymbolicRegister(i->nnn(), 0, MakeACopyOf(Op2Expr[0]));
	TheLabels.WriteSymbolicRegister(i->nnn(), 1, MakeACopyOf(Op2Expr[1]));
	TheLabels.WriteSymbolicRegister(i->nnn(), 2, NULL);
	TheLabels.WriteSymbolicRegister(i->nnn(), 3, NULL);
  }
#endif
#endif /* BX_CPU_LEVEL < 3 */
}


  void
BX_CPU_C::XCHG_EdGd(bxInstruction_c *i)
{
    Bit32u op2_32, op1_32;
    Bit8u op1_integrity, op2_integrity;
    Expression *Op2Expr[4];
    Expression *Op1Expr[4];
    int rm, nnn;

    /* op2_32 is a register, op2_addr is an index of a register */
    nnn = i->nnn();
    op2_32 = BX_READ_32BIT_REG(nnn);
    op2_integrity = BX_READ_32BIT_INTEGRITY(nnn);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	Op2Expr[0] = MakeACopyOf(TheLabels.ReadSymbolicRegister(nnn, 0));
	Op2Expr[1] = MakeACopyOf(TheLabels.ReadSymbolicRegister(nnn, 1));
	Op2Expr[2] = MakeACopyOf(TheLabels.ReadSymbolicRegister(nnn, 2));
	Op2Expr[3] = MakeACopyOf(TheLabels.ReadSymbolicRegister(nnn, 3));
  }
#endif

    /* op1_32 is a register or memory reference */
    if (i->modC0()) {
      rm = i->rm();
      op1_32 = BX_READ_32BIT_REG(rm);
      op1_integrity = BX_READ_32BIT_INTEGRITY(rm);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	Op2Expr[0] = MakeACopyOf(TheLabels.ReadSymbolicRegister(rm, 0));
	Op2Expr[1] = MakeACopyOf(TheLabels.ReadSymbolicRegister(rm, 1));
	Op2Expr[2] = MakeACopyOf(TheLabels.ReadSymbolicRegister(rm, 2));
	Op2Expr[3] = MakeACopyOf(TheLabels.ReadSymbolicRegister(rm, 3));
  }
#endif
      BX_WRITE_32BIT_REGZ(rm, op2_32);
      BX_WRITE_32BIT_REG_INTEGRITY(rm, op2_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	TheLabels.WriteSymbolicRegister(rm, 0, Op2Expr[0]);
  	TheLabels.WriteSymbolicRegister(rm, 1, Op2Expr[1]);
  	TheLabels.WriteSymbolicRegister(rm, 2, Op2Expr[2]);
  	TheLabels.WriteSymbolicRegister(rm, 3, Op2Expr[3]);
  }
#endif
      }
    else {
      /* pointer, segment address pair */
      read_RMW_virtual_dword(i->seg(), RMAddr(i), &op1_32, &op1_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	read_virtual_expression(i->seg(), RMAddr(i), &(Op1Expr[0]));
  	read_virtual_expression(i->seg(), RMAddr(i) + 1, &(Op1Expr[1]));
  	read_virtual_expression(i->seg(), RMAddr(i) + 2, &(Op1Expr[2]));
  	read_virtual_expression(i->seg(), RMAddr(i) + 3, &(Op1Expr[3]));
	/*Op1Expr[0] = MakeACopyOf(Op1Expr[0]);
	Op1Expr[1] = MakeACopyOf(Op1Expr[1]);
	Op1Expr[2] = MakeACopyOf(Op1Expr[2]);
	Op1Expr[3] = MakeACopyOf(Op1Expr[3]);*/
  }
#endif
      Write_RMW_virtual_dword(op2_32, op2_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	write_virtual_expression(i->seg(), RMAddr(i), Op2Expr[0]);
  	write_virtual_expression(i->seg(), RMAddr(i) + 1, Op2Expr[1]);
  	write_virtual_expression(i->seg(), RMAddr(i) + 2, Op2Expr[2]);
  	write_virtual_expression(i->seg(), RMAddr(i) + 3, Op2Expr[3]);
  }
#endif
      }

      nnn = i->nnn();
    BX_WRITE_32BIT_REGZ(nnn, op1_32);
    BX_WRITE_32BIT_REG_INTEGRITY(nnn, op1_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	if (Op1Expr[0] != NULL)
	{
		if ((unsigned int) Op1Expr[0] < 5) 
		{
			printf("i->nnn() == %d\n", i->nnn());
			printf("i->seg():RMAddr(i) == %x:%08x\n", i->seg(), RMAddr(i));
			printf("Op1Expr[0] = %08x\n", Op1Expr[0]);
			printf("Op1Expr[1] = %08x\n", Op1Expr[1]);
			printf("Op1Expr[2] = %08x\n", Op1Expr[2]);
			printf("Op1Expr[3] = %08x\n", Op1Expr[3]);
			Op1Expr[0] = NULL;
			Op1Expr[1] = NULL;
			Op1Expr[2] = NULL;
			Op1Expr[3] = NULL;
			fflush(stdout);
			//BX_PANIC(("Gotcha!")); 
		}
	}
  	TheLabels.WriteSymbolicRegister(nnn, 0, Op1Expr[0]);
  	TheLabels.WriteSymbolicRegister(nnn, 1, Op1Expr[1]);
  	TheLabels.WriteSymbolicRegister(nnn, 2, Op1Expr[2]);
  	TheLabels.WriteSymbolicRegister(nnn, 3, Op1Expr[3]);
  }
#endif
}


  void
BX_CPU_C::CMOV_GdEd(bxInstruction_c *i)
{
#if (BX_CPU_LEVEL >= 6) || (BX_CPU_LEVEL_HACKED >= 6)
  // Note: CMOV accesses a memory source operand (read), regardless
  //       of whether condition is true or not.  Thus, exceptions may
  //       occur even if the MOV does not take place.

  bx_bool condition;
  Bit32u op2_32;
  Bit8u op2_integrity;
  Expression *Op2Expr[4];


  switch (i->b1()) {
    // CMOV opcodes:
    case 0x140: condition = get_OF(); break;
    case 0x141: condition = !get_OF(); break;
    case 0x142: condition = get_CF(); break;
    case 0x143: condition = !get_CF(); break;
    case 0x144: condition = get_ZF(); break;
    case 0x145: condition = !get_ZF(); break;
    case 0x146: condition = get_CF() || get_ZF(); break;
    case 0x147: condition = !get_CF() && !get_ZF(); break;
    case 0x148: condition = get_SF(); break;
    case 0x149: condition = !get_SF(); break;
    case 0x14A: condition = get_PF(); break;
    case 0x14B: condition = !get_PF(); break;
    case 0x14C: condition = getB_SF() != getB_OF(); break;
    case 0x14D: condition = getB_SF() == getB_OF(); break;
    case 0x14E: condition = get_ZF() || (getB_SF() != getB_OF()); break;
    case 0x14F: condition = !get_ZF() && (getB_SF() == getB_OF()); break;
    default:
      condition = 0;
      BX_PANIC(("CMOV_GdEd: default case"));
    }

  if (i->modC0()) {
    op2_32 = BX_READ_32BIT_REG(i->rm());
    op2_integrity = BX_READ_32BIT_INTEGRITY(i->rm());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	Op2Expr[0] = TheLabels.ReadSymbolicRegister(i->rm(), 0);
	Op2Expr[1] = TheLabels.ReadSymbolicRegister(i->rm(), 1);
	Op2Expr[2] = TheLabels.ReadSymbolicRegister(i->rm(), 2);
	Op2Expr[3] = TheLabels.ReadSymbolicRegister(i->rm(), 3);
  }
#endif

    }
  else {
    /* pointer, segment address pair */
    read_virtual_dword(i->seg(), RMAddr(i), &op2_32, &op2_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
    	read_virtual_expression(i->seg(), RMAddr(i), &(Op2Expr[0]));
  	read_virtual_expression(i->seg(), RMAddr(i) + 1, &(Op2Expr[1]));
  	read_virtual_expression(i->seg(), RMAddr(i) + 2, &(Op2Expr[2]));
  	read_virtual_expression(i->seg(), RMAddr(i) + 3, &(Op2Expr[3]));
  }
#endif

    }

  if (condition) {
    BX_WRITE_32BIT_REGZ(i->nnn(), op2_32);
    BX_WRITE_32BIT_REG_INTEGRITY(i->nnn(), op2_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	TheLabels.WriteSymbolicRegister(i->nnn(), 0, MakeACopyOf(Op2Expr[0]));
  	TheLabels.WriteSymbolicRegister(i->nnn(), 1, MakeACopyOf(Op2Expr[1]));
  	TheLabels.WriteSymbolicRegister(i->nnn(), 2, MakeACopyOf(Op2Expr[2]));
  	TheLabels.WriteSymbolicRegister(i->nnn(), 3, MakeACopyOf(Op2Expr[3]));
  }
#endif
    }
#else
  BX_INFO(("cmov_gded called"));
  UndefinedOpcode(i);
#endif
}
