/////////////////////////////////////////////////////////////////////////
// $Id: logical32.cc,v 1.19 2002/10/25 18:26:28 sshwarts Exp $
/////////////////////////////////////////////////////////////////////////
//
//  Copyright (C) 2001  MandrakeSoft S.A.
//
//    MandrakeSoft S.A.
//    43, rue d'Aboukir
//    75002 Paris - France
//    http://www.linux-mandrake.com/
//    http://www.mandrakesoft.com/
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA






#define NEED_CPU_REG_SHORTCUTS 1
#include "bochs.h"
#define LOG_THIS BX_CPU_THIS_PTR




  void
BX_CPU_C::XOR_EdGd(bxInstruction_c *i)
{
  Bit32u op2_32, op1_32, result_32;
  Bit8u result_integrity;
  Bit8u op1_integrity, op2_integrity;
  Expression *Op1Expr, *Op2Expr, *LogicalExpr;

  op2_32 = BX_READ_32BIT_REG(i->nnn());
  op2_integrity = BX_READ_32BIT_INTEGRITY(i->nnn());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op2Expr = (Expression *) MakeNewQuadReg(i->nnn());
  }
#endif

  if (i->modC0()) {
    op1_32 = BX_READ_32BIT_REG(i->rm());
    op1_integrity = BX_READ_32BIT_INTEGRITY(i->rm());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op1Expr = (Expression *) MakeNewQuadReg(i->rm());
  }
#endif
    result_32 = op1_32 ^ op2_32;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	if (i->nnn() == i->rm())
		LogicalExpr = NULL;
	else
		LogicalExpr = (Expression *) new Operation(Op1Expr, Op2Expr, "XOR_EdGd");
  }
#endif
    BX_WRITE_32BIT_REGZ(i->rm(), result_32);
    result_integrity = low_water_mark(op1_integrity, op2_integrity, INTEG_DOUBLE, INTEG_DOUBLE);
    BX_WRITE_32BIT_REG_INTEGRITY(i->rm(), result_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	WriteSymbolicQuadRegister(i->rm(), LogicalExpr);
	//if (Op1Expr != NULL) delete Op1Expr;
	//if (Op2Expr != NULL) delete Op2Expr;
  }
#endif
    }
  else {
    read_RMW_virtual_dword(i->seg(), RMAddr(i), &op1_32, &op1_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	MakeNewQuadMem(i->seg(), RMAddr(i), Op1Expr);
  }
#endif
    result_32 = op1_32 ^ op2_32;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	LogicalExpr = (Expression *) new Operation(Op1Expr, Op2Expr, "XOR_EdGd");
  }
#endif
    result_integrity = low_water_mark(op1_integrity, op2_integrity, INTEG_DOUBLE, INTEG_DOUBLE);
    Write_RMW_virtual_dword(result_32, result_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	WriteSymbolicQuadMem(i->seg(), RMAddr(i), LogicalExpr);
	//if (Op1Expr != NULL) delete Op1Expr;
	//if (Op2Expr != NULL) delete Op2Expr;
  }
#endif
    }

  SET_FLAGS_OSZAPC_32(op1_32, op2_32, result_32, BX_INSTR_XOR32);
}


  void
BX_CPU_C::XOR_GdEd(bxInstruction_c *i)
{
  Bit32u op1_32, op2_32, result_32;
  unsigned nnn = i->nnn();
  Bit8u op2_integrity, op1_integrity, result_integrity;
  Expression *Op1Expr, *Op2Expr, *LogicalExpr;

  op1_32 = BX_READ_32BIT_REG(nnn);
  op1_integrity = BX_READ_32BIT_INTEGRITY(nnn);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op1Expr = (Expression *) MakeNewQuadReg(nnn);
  }
#endif

  if (i->modC0()) {
    op2_32 = BX_READ_32BIT_REG(i->rm());
    op2_integrity = BX_READ_32BIT_INTEGRITY(i->rm());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op2Expr = (Expression *) MakeNewQuadReg(i->rm());
  }
#endif
    }
  else {
    read_virtual_dword(i->seg(), RMAddr(i), &op2_32, &op2_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	MakeNewQuadMem(i->seg(), RMAddr(i), Op2Expr);
  }
#endif
    }

  result_32 = op1_32 ^ op2_32;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	if ( (i->modC0()) && (i->nnn() == i->rm()) )
		LogicalExpr = NULL;
	else
  		LogicalExpr = (Expression *) new Operation(Op1Expr, Op2Expr, "XOR_GdEd");
  }
#endif

  BX_WRITE_32BIT_REGZ(nnn, result_32);
  result_integrity = low_water_mark(op1_integrity, op2_integrity, INTEG_DOUBLE, INTEG_DOUBLE);
  BX_WRITE_32BIT_REG_INTEGRITY(nnn, result_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	WriteSymbolicQuadRegister(nnn, LogicalExpr);
	//if (Op1Expr != NULL) delete Op1Expr;
	//if (Op2Expr != NULL) delete Op2Expr;
  }
#endif

  SET_FLAGS_OSZAPC_32(op1_32, op2_32, result_32, BX_INSTR_XOR32);
}


  void
BX_CPU_C::XOR_EAXId(bxInstruction_c *i)
{
  Bit32u op1_32, op2_32, sum_32;
  Bit8u op1_integrity, op2_integrity, result_integrity;
  Expression *Op1Expr, *Op2Expr, *LogicalExpr;

  op1_32 = EAX;
  op1_integrity = EAX_INTEGRITY;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op1Expr = (Expression *) MakeNewQuadReg(0);
  }
#endif
  op2_32 = i->Id();
  op2_integrity = 0xFF;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	MakeNewQuadConstant(i->Id(), Op2Expr);
  }
#endif

  sum_32 = op1_32 ^ op2_32;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	if (!EffectivelyNull(Op1Expr))
		LogicalExpr = (Expression *) new Operation(Op1Expr, Op2Expr, "XOR_EAXId");
	else
		LogicalExpr = NULL;
  }
#endif

  result_integrity = low_water_mark(op1_integrity, op2_integrity, INTEG_DOUBLE, INTEG_DOUBLE);

#if BX_SUPPORT_X86_64
  RAX = sum_32;
#else
  EAX = sum_32;
  //LVAL_EAX_INTEGRITY = result_integrity;
  BX_WRITE_32BIT_REG_INTEGRITY(0, result_integrity);
#endif
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	WriteSymbolicQuadRegister(0, LogicalExpr);
	//if (Op1Expr != NULL) delete Op1Expr;
	//if (Op2Expr != NULL) delete Op2Expr;
  }
#endif

  SET_FLAGS_OSZAPC_32(op1_32, op2_32, sum_32, BX_INSTR_XOR32);
}

  void
BX_CPU_C::XOR_EdId(bxInstruction_c *i)
{
  Bit32u op2_32, op1_32, result_32;
  Bit8u result_integrity;
  Bit8u op1_integrity, op2_integrity;
  Expression *Op1Expr, *Op2Expr, *LogicalExpr;

  op2_32 = i->Id();
  op2_integrity = 0xFF;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	MakeNewQuadConstant(i->Id(), Op2Expr);
  }
#endif

  if (i->modC0()) {
    op1_32 = BX_READ_32BIT_REG(i->rm());
    op1_integrity = BX_READ_32BIT_INTEGRITY(i->rm());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op1Expr = (Expression *) MakeNewQuadReg(i->rm());
  }
#endif
    result_32 = op1_32 ^ op2_32;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	if (!EffectivelyNull(Op1Expr))
		LogicalExpr = (Expression *) new Operation(Op1Expr, Op2Expr, "XOR_EdId");
	else
		LogicalExpr = NULL;
  }
#endif
    BX_WRITE_32BIT_REGZ(i->rm(), result_32);
    result_integrity = low_water_mark(op1_integrity, op2_integrity, INTEG_DOUBLE, INTEG_DOUBLE);
    BX_WRITE_32BIT_REG_INTEGRITY(i->rm(), result_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	WriteSymbolicQuadRegister(i->rm(), LogicalExpr);
	//if (Op1Expr != NULL) delete Op1Expr;
	//if (Op2Expr != NULL) delete Op2Expr;
  }
#endif
    }
  else {
    read_RMW_virtual_dword(i->seg(), RMAddr(i), &op1_32, &op1_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	MakeNewQuadMem(i->seg(), RMAddr(i), Op1Expr);
  }
#endif
    result_32 = op1_32 ^ op2_32;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	if (!EffectivelyNull(Op1Expr))
		LogicalExpr = (Expression *) new Operation(Op1Expr, Op2Expr, "XOR_EdId");
	else
		LogicalExpr = NULL;
  }
#endif
    result_integrity = low_water_mark(op1_integrity, op2_integrity, INTEG_DOUBLE, INTEG_DOUBLE);
    Write_RMW_virtual_dword(result_32, result_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	WriteSymbolicQuadMem(i->seg(), RMAddr(i), LogicalExpr);
	//if (Op1Expr != NULL) delete Op1Expr;
	//if (Op2Expr != NULL) delete Op2Expr;
  }
#endif
    }

  SET_FLAGS_OSZAPC_32(op1_32, op2_32, result_32, BX_INSTR_XOR32);
}


  void
BX_CPU_C::OR_EdId(bxInstruction_c *i)
{
  Bit32u op2_32, op1_32, result_32;
  Bit8u result_integrity;
  Bit8u op1_integrity, op2_integrity;
  Expression *Op1Expr, *Op2Expr, *LogicalExpr;

  op2_32 = i->Id();
  op2_integrity = 0xFF;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	MakeNewQuadConstant(i->Id(), Op2Expr);
  }
#endif

  if (i->modC0()) {
    op1_32 = BX_READ_32BIT_REG(i->rm());
    op1_integrity = BX_READ_32BIT_INTEGRITY(i->rm());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op1Expr = (Expression *) MakeNewQuadReg(i->rm());
  }
#endif
    result_32 = op1_32 | op2_32;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	if (!EffectivelyNull(Op1Expr))
		LogicalExpr = (Expression *) new Operation(Op1Expr, Op2Expr, "OR_EdId");
	else
		LogicalExpr = NULL;
  }
#endif
    BX_WRITE_32BIT_REGZ(i->rm(), result_32);
    result_integrity = low_water_mark(op1_integrity, op2_integrity, INTEG_DOUBLE, INTEG_DOUBLE);
    BX_WRITE_32BIT_REG_INTEGRITY(i->rm(), result_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	WriteSymbolicQuadRegister(i->rm(), LogicalExpr);
	//if (Op1Expr != NULL) delete Op1Expr;
	//if (Op2Expr != NULL) delete Op2Expr;
  }
#endif
    }
  else {
    read_RMW_virtual_dword(i->seg(), RMAddr(i), &op1_32, &op1_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	MakeNewQuadMem(i->seg(), RMAddr(i), Op1Expr);
  }
#endif
    result_32 = op1_32 | op2_32;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	if (!EffectivelyNull(Op1Expr))
		LogicalExpr = (Expression *) new Operation(Op1Expr, Op2Expr, "OR_EdId");
	else
		LogicalExpr = NULL;
  }
#endif
    result_integrity = low_water_mark(op1_integrity, op2_integrity, INTEG_DOUBLE, INTEG_DOUBLE);
    Write_RMW_virtual_dword(result_32, result_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	WriteSymbolicQuadMem(i->seg(), RMAddr(i), LogicalExpr);
	//if (Op1Expr != NULL) delete Op1Expr;
	//if (Op2Expr != NULL) delete Op2Expr;
  }
#endif
    }

  SET_FLAGS_OSZAPC_32(op1_32, op2_32, result_32, BX_INSTR_OR32);
}

  void
BX_CPU_C::NOT_Ed(bxInstruction_c *i)
{
  Bit32u op1_32, result_32;
  Bit8u result_integrity;
  Bit8u op1_integrity;
  Expression *Op1Expr, *LogicalExpr;

  if (i->modC0()) {
    op1_32 = BX_READ_32BIT_REG(i->rm());
    op1_integrity = BX_READ_32BIT_INTEGRITY(i->rm());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op1Expr = (Expression *) MakeNewQuadReg(i->rm());
  }
#endif
    result_32 = ~op1_32;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	LogicalExpr = (Expression *) new Operation(Op1Expr, NULL, "NOT_Ed");
  }
#endif
    BX_WRITE_32BIT_REGZ(i->rm(), result_32);
    result_integrity = low_water_mark(op1_integrity, op1_integrity, INTEG_DOUBLE, INTEG_DOUBLE);
    BX_WRITE_32BIT_REG_INTEGRITY(i->rm(), result_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	WriteSymbolicQuadRegister(i->rm(), LogicalExpr);
	//if (Op1Expr != NULL) delete Op1Expr;
  }
#endif
    }
  else {
    read_RMW_virtual_dword(i->seg(), RMAddr(i), &op1_32, &op1_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	MakeNewQuadMem(i->seg(), RMAddr(i), Op1Expr);
  }
#endif
    result_32 = ~op1_32;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	LogicalExpr = (Expression *) new Operation(Op1Expr, NULL, "NOT_Ed");
  }
#endif
    result_integrity = low_water_mark(op1_integrity, op1_integrity, INTEG_DOUBLE, INTEG_DOUBLE);
    Write_RMW_virtual_dword(result_32, result_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	WriteSymbolicQuadMem(i->seg(), RMAddr(i), LogicalExpr);
	//if (Op1Expr != NULL) delete Op1Expr;
  }
#endif
    }
}


  void
BX_CPU_C::OR_EdGd(bxInstruction_c *i)
{
  Bit32u op2_32, op1_32, result_32;
  Bit8u result_integrity;
  Bit8u op1_integrity, op2_integrity;
  Expression *Op1Expr, *Op2Expr, *LogicalExpr;

  op2_32 = BX_READ_32BIT_REG(i->nnn());
  op2_integrity = BX_READ_32BIT_INTEGRITY(i->nnn());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op2Expr = (Expression *) MakeNewQuadReg(i->nnn());
  }
#endif

  if (i->modC0()) {
    op1_32 = BX_READ_32BIT_REG(i->rm());
    op1_integrity = BX_READ_32BIT_INTEGRITY(i->rm());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op1Expr = (Expression *) MakeNewQuadReg(i->rm());
  }
#endif
    result_32 = op1_32 | op2_32;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	LogicalExpr = (Expression *) new Operation(Op1Expr, Op2Expr, "OR_EdGd");
  }
#endif
    BX_WRITE_32BIT_REGZ(i->rm(), result_32);
    result_integrity = low_water_mark(op1_integrity, op2_integrity, INTEG_DOUBLE, INTEG_DOUBLE);
    BX_WRITE_32BIT_REG_INTEGRITY(i->rm(), result_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	WriteSymbolicQuadRegister(i->rm(), LogicalExpr);
	//if (Op1Expr != NULL) delete Op1Expr;
	//if (Op2Expr != NULL) delete Op2Expr;
  }
#endif
    }
  else {
    read_RMW_virtual_dword(i->seg(), RMAddr(i), &op1_32, &op1_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	MakeNewQuadMem(i->seg(), RMAddr(i), Op1Expr);
  }
#endif
    result_32 = op1_32 | op2_32;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	LogicalExpr = (Expression *) new Operation(Op1Expr, Op2Expr, "OR_EdGd");
  }
#endif
    result_integrity = low_water_mark(op1_integrity, op2_integrity, INTEG_DOUBLE, INTEG_DOUBLE);
    Write_RMW_virtual_dword(result_32, result_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	WriteSymbolicQuadMem(i->seg(), RMAddr(i), LogicalExpr);
	//if (Op1Expr != NULL) delete Op1Expr;
	//if (Op2Expr != NULL) delete Op2Expr;
  }
#endif
    }

  SET_FLAGS_OSZAPC_32(op1_32, op2_32, result_32, BX_INSTR_OR32);
}


  void
BX_CPU_C::OR_GdEd(bxInstruction_c *i)
{
  Bit32u op1_32, op2_32, result_32;
  Bit8u op2_integrity, op1_integrity, result_integrity;
  Expression *Op1Expr, *Op2Expr, *LogicalExpr;

  op1_32 = BX_READ_32BIT_REG(i->nnn());
  op1_integrity = BX_READ_32BIT_INTEGRITY(i->nnn());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op1Expr = (Expression *) MakeNewQuadReg(i->nnn());
  }
#endif

  if (i->modC0()) {
    op2_32 = BX_READ_32BIT_REG(i->rm());
    op2_integrity = BX_READ_32BIT_INTEGRITY(i->rm());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op2Expr = (Expression *) MakeNewQuadReg(i->rm());
  }
#endif
    }
  else {
    read_virtual_dword(i->seg(), RMAddr(i), &op2_32, &op2_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	MakeNewQuadMem(i->seg(), RMAddr(i), Op2Expr);
  }
#endif
    }

#if (defined(__i386__) && defined(__GNUC__) && BX_SupportHostAsms)
  Bit32u flags32;

  asmOr32(result_32, op1_32, op2_32, flags32);
  setEFlagsOSZAPC(flags32);
#else
  result_32 = op1_32 | op2_32;
#endif
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	LogicalExpr = (Expression *) new Operation(Op1Expr, Op2Expr, "OR_GdEd");
  }
#endif


  BX_WRITE_32BIT_REGZ(i->nnn(), result_32);
  result_integrity = low_water_mark(op1_integrity, op2_integrity, INTEG_DOUBLE, INTEG_DOUBLE);
  BX_WRITE_32BIT_REG_INTEGRITY(i->nnn(), result_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	WriteSymbolicQuadRegister(i->nnn(), LogicalExpr);
	//if (Op1Expr != NULL) delete Op1Expr;
	//if (Op2Expr != NULL) delete Op2Expr;
  }
#endif

#if !(defined(__i386__) && defined(__GNUC__) && BX_SupportHostAsms)
  SET_FLAGS_OSZAPC_32(op1_32, op2_32, result_32, BX_INSTR_OR32);
#endif
}


  void
BX_CPU_C::OR_EAXId(bxInstruction_c *i)
{
  Bit32u op1_32, op2_32, sum_32;
  Bit8u op1_integrity, op2_integrity, result_integrity;
  Expression *Op1Expr, *Op2Expr, *LogicalExpr;

  op1_32 = EAX;
  op1_integrity = EAX_INTEGRITY;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op1Expr = (Expression *) MakeNewQuadReg(0);
  }
#endif
  op2_32 = i->Id();
  op2_integrity = 0xFF;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	MakeNewQuadConstant(i->Id(), Op2Expr);
  }
#endif

  sum_32 = op1_32 | op2_32;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	if (!EffectivelyNull(Op1Expr))
		LogicalExpr = (Expression *) new Operation(Op1Expr, Op2Expr, "OR_EAXId");
	else
		LogicalExpr = NULL;
  }
#endif

#if BX_SUPPORT_X86_64
  RAX = sum_32;
#else
  EAX = sum_32;
#endif

  result_integrity = low_water_mark(op1_integrity, op2_integrity, INTEG_DOUBLE, INTEG_DOUBLE);
  //LVAL_EAX_INTEGRITY = result_integrity;
  BX_WRITE_32BIT_REG_INTEGRITY(0, result_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	WriteSymbolicQuadRegister(0, LogicalExpr);
	//if (Op1Expr != NULL) delete Op1Expr;
	//if (Op2Expr != NULL) delete Op2Expr;
  }
#endif


  SET_FLAGS_OSZAPC_32(op1_32, op2_32, sum_32, BX_INSTR_OR32);
}



  void
BX_CPU_C::AND_EdGd(bxInstruction_c *i)
{
  Bit32u op2_32, op1_32, result_32;
  Bit8u result_integrity;
  Bit8u op1_integrity, op2_integrity;
  Expression *Op1Expr, *Op2Expr, *LogicalExpr;

  op2_32 = BX_READ_32BIT_REG(i->nnn());
  op2_integrity = BX_READ_32BIT_INTEGRITY(i->nnn());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op2Expr = (Expression *) MakeNewQuadReg(i->nnn());
  }
#endif

  if (i->modC0()) {
    op1_32 = BX_READ_32BIT_REG(i->rm());
    op1_integrity = BX_READ_32BIT_INTEGRITY(i->rm());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op1Expr = (Expression *) MakeNewQuadReg(i->rm());
  }
#endif

#if (defined(__i386__) && defined(__GNUC__) && BX_SupportHostAsms)
    Bit32u flags32;

    asmAnd32(result_32, op1_32, op2_32, flags32);
    setEFlagsOSZAPC(flags32);
#else
    result_32 = op1_32 & op2_32;
#endif
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	LogicalExpr = (Expression *) new Operation(Op1Expr, Op2Expr, "AND_EdGd");
  }
#endif


    BX_WRITE_32BIT_REGZ(i->rm(), result_32);
    result_integrity = low_water_mark(op1_integrity, op2_integrity, INTEG_DOUBLE, INTEG_DOUBLE);
    BX_WRITE_32BIT_REG_INTEGRITY(i->rm(), result_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	WriteSymbolicQuadRegister(i->rm(), LogicalExpr);
	//if (Op1Expr != NULL) delete Op1Expr;
	//if (Op2Expr != NULL) delete Op2Expr;
  }
#endif
    }
  else {
    read_RMW_virtual_dword(i->seg(), RMAddr(i), &op1_32, &op1_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	MakeNewQuadMem(i->seg(), RMAddr(i), Op1Expr);
  }
#endif

#if (defined(__i386__) && defined(__GNUC__) && BX_SupportHostAsms)
    Bit32u flags32;

    asmAnd32(result_32, op1_32, op2_32, flags32);
    setEFlagsOSZAPC(flags32);
#else
    result_32 = op1_32 & op2_32;
#endif
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	LogicalExpr = (Expression *) new Operation(Op1Expr, Op2Expr, "AND_EdGd");
  }
#endif

    result_integrity = low_water_mark(op1_integrity, op2_integrity, INTEG_DOUBLE, INTEG_DOUBLE);
    Write_RMW_virtual_dword(result_32, result_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	WriteSymbolicQuadMem(i->seg(), RMAddr(i), LogicalExpr);
	//if (Op1Expr != NULL) delete Op1Expr;
	//if (Op2Expr != NULL) delete Op2Expr;
  }
#endif
    }

#if !(defined(__i386__) && defined(__GNUC__) && BX_SupportHostAsms)
  SET_FLAGS_OSZAPC_32(op1_32, op2_32, result_32, BX_INSTR_AND32);
#endif
}


  void
BX_CPU_C::AND_GdEd(bxInstruction_c *i)
{
  Bit32u op1_32, op2_32, result_32;
  Bit8u op2_integrity, op1_integrity, result_integrity;
  Expression *Op1Expr, *Op2Expr, *LogicalExpr;

  op1_32 = BX_READ_32BIT_REG(i->nnn());
  op1_integrity = BX_READ_32BIT_INTEGRITY(i->nnn());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op1Expr = (Expression *) MakeNewQuadReg(i->nnn());
  }
#endif

  if (i->modC0()) {
    op2_32 = BX_READ_32BIT_REG(i->rm());
    op2_integrity = BX_READ_32BIT_INTEGRITY(i->rm());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op2Expr = (Expression *) MakeNewQuadReg(i->rm());
  }
#endif
    }
  else {
    read_virtual_dword(i->seg(), RMAddr(i), &op2_32, &op2_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	MakeNewQuadMem(i->seg(), RMAddr(i), Op2Expr);
  }
#endif
    }

#if (defined(__i386__) && defined(__GNUC__) && BX_SupportHostAsms)
  Bit32u flags32;

  asmAnd32(result_32, op1_32, op2_32, flags32);
  setEFlagsOSZAPC(flags32);
#else
  result_32 = op1_32 & op2_32;
#endif
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	LogicalExpr = (Expression *) new Operation(Op1Expr, Op2Expr, "AND_GdEd");
  }
#endif

  BX_WRITE_32BIT_REGZ(i->nnn(), result_32);
  result_integrity = low_water_mark(op1_integrity, op2_integrity, INTEG_DOUBLE, INTEG_DOUBLE);
  BX_WRITE_32BIT_REG_INTEGRITY(i->nnn(), result_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	WriteSymbolicQuadRegister(i->nnn(), LogicalExpr);
	//if (Op1Expr != NULL) delete Op1Expr;
	//if (Op2Expr != NULL) delete Op2Expr;
  }
#endif

#if !(defined(__i386__) && defined(__GNUC__) && BX_SupportHostAsms)
  SET_FLAGS_OSZAPC_32(op1_32, op2_32, result_32, BX_INSTR_AND32);
#endif
}


  void
BX_CPU_C::AND_EAXId(bxInstruction_c *i)
{
  Bit32u op1_32, op2_32, result_32;
  Bit8u op1_integrity, op2_integrity, result_integrity;
  Expression *Op1Expr, *Op2Expr, *LogicalExpr;

  op1_32 = EAX;
  op1_integrity = EAX_INTEGRITY;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op1Expr = (Expression *) MakeNewQuadReg(0);
  }
#endif
  op2_32 = i->Id();
  op2_integrity = 0xFF;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	MakeNewQuadConstant(i->Id(), Op2Expr);
  }
#endif

#if (defined(__i386__) && defined(__GNUC__) && BX_SupportHostAsms)
  Bit32u flags32;

  asmAnd32(result_32, op1_32, op2_32, flags32);
  setEFlagsOSZAPC(flags32);
#else
  result_32 = op1_32 & op2_32;
#endif

#if BX_SUPPORT_X86_64
  RAX = result_32;
#else
  EAX = result_32;
#endif
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	if (!EffectivelyNull(Op1Expr))
		LogicalExpr = (Expression *) new Operation(Op1Expr, Op2Expr, "AND_EAXId");
	else
		LogicalExpr = NULL;
  }
#endif

    result_integrity = low_water_mark(op1_integrity, op2_integrity, INTEG_DOUBLE, INTEG_DOUBLE);
    //LVAL_EAX_INTEGRITY = result_integrity;
    BX_WRITE_32BIT_REG_INTEGRITY(0, result_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	WriteSymbolicQuadRegister(0, LogicalExpr);
	//if (Op1Expr != NULL) delete Op1Expr;
	//if (Op2Expr != NULL) delete Op2Expr;
  }
#endif

#if !(defined(__i386__) && defined(__GNUC__) && BX_SupportHostAsms)
  SET_FLAGS_OSZAPC_32(op1_32, op2_32, result_32, BX_INSTR_AND32);
#endif
}

  void
BX_CPU_C::AND_EdId(bxInstruction_c *i)
{
  Bit32u op2_32, op1_32, result_32;
  Bit8u result_integrity;
  Bit8u op1_integrity, op2_integrity;
  Expression *Op1Expr, *Op2Expr, *LogicalExpr;

  op2_32 = i->Id();
  op2_integrity = 0xFF;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	MakeNewQuadConstant(i->Id(), Op2Expr);
  }
#endif

  if (i->modC0()) {
    op1_32 = BX_READ_32BIT_REG(i->rm());
    op1_integrity = BX_READ_32BIT_INTEGRITY(i->rm());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op1Expr = (Expression *) MakeNewQuadReg(i->rm());
  }
#endif

#if (defined(__i386__) && defined(__GNUC__) && BX_SupportHostAsms)
    Bit32u flags32;

    asmAnd32(result_32, op1_32, op2_32, flags32);
    setEFlagsOSZAPC(flags32);
#else
    result_32 = op1_32 & op2_32;
#endif
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	if (!EffectivelyNull(Op1Expr))
		LogicalExpr = (Expression *) new Operation(Op1Expr, Op2Expr, "AND_EdId");
	else
		LogicalExpr = NULL;
  }
#endif

    BX_WRITE_32BIT_REGZ(i->rm(), result_32);
    result_integrity = low_water_mark(op1_integrity, op2_integrity, INTEG_DOUBLE, INTEG_DOUBLE);
    BX_WRITE_32BIT_REG_INTEGRITY(i->rm(), result_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
	WriteSymbolicQuadRegister(i->rm(), LogicalExpr);
	//if (Op1Expr != NULL) delete Op1Expr;
	//if (Op2Expr != NULL) delete Op2Expr;
  }
#endif
    }
  else {
    read_RMW_virtual_dword(i->seg(), RMAddr(i), &op1_32, &op1_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	MakeNewQuadMem(i->seg(), RMAddr(i), Op1Expr);
  }
#endif

#if (defined(__i386__) && defined(__GNUC__) && BX_SupportHostAsms)
    Bit32u flags32;

    asmAnd32(result_32, op1_32, op2_32, flags32);
    setEFlagsOSZAPC(flags32);
#else
    result_32 = op1_32 & op2_32;
#endif
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	if (!EffectivelyNull(Op1Expr))
		LogicalExpr = (Expression *) new Operation(Op1Expr, Op2Expr, "AND_EdId");
	else
		LogicalExpr = NULL;
  }
#endif
    result_integrity = low_water_mark(op1_integrity, op2_integrity, INTEG_DOUBLE, INTEG_DOUBLE);

    Write_RMW_virtual_dword(result_32, result_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	WriteSymbolicQuadMem(i->seg(), RMAddr(i), LogicalExpr);
	//if (Op1Expr != NULL) delete Op1Expr;
	//if (Op2Expr != NULL) delete Op2Expr;
  }
#endif
    }

#if !(defined(__i386__) && defined(__GNUC__) && BX_SupportHostAsms)
  SET_FLAGS_OSZAPC_32(op1_32, op2_32, result_32, BX_INSTR_AND32);
#endif
}


  void
BX_CPU_C::TEST_EdGd(bxInstruction_c *i)
{
  Bit32u op2_32, op1_32;
  Bit8u op1_integrity, op2_integrity;
  Expression *Op1Expr, *Op2Expr;

  op2_32 = BX_READ_32BIT_REG(i->nnn());
  op2_integrity = BX_READ_32BIT_INTEGRITY(i->nnn());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op2Expr = (Expression *) MakeNewQuadReg(i->nnn());
  }
#endif

  if (i->modC0()) {
    op1_32 = BX_READ_32BIT_REG(i->rm());
    op1_integrity = BX_READ_32BIT_INTEGRITY(i->rm());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op1Expr = (Expression *) MakeNewQuadReg(i->rm());
  }
#endif
    }
  else {
    read_virtual_dword(i->seg(), RMAddr(i), &op1_32, &op1_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	MakeNewQuadMem(i->seg(), RMAddr(i), Op1Expr);
  }
#endif
    }

#if (defined(__i386__) && defined(__GNUC__) && BX_SupportHostAsms)
  Bit32u flags32;

  asmTest32(op1_32, op2_32, flags32);
  setEFlagsOSZAPC(flags32);
#else
  Bit32u result_32;
  result_32 = op1_32 & op2_32;

  SET_FLAGS_OSZAPC_32_WITHEXPR(op1_32, op2_32, result_32, BX_INSTR_TEST32, Op1Expr, Op2Expr);
#endif
}



  void
BX_CPU_C::TEST_EAXId(bxInstruction_c *i)
{
  Bit32u op2_32, op1_32;
  Expression *Op1Expr, *Op2Expr;

  op1_32 = EAX;
  op2_32 = i->Id();
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op1Expr = (Expression *) MakeNewQuadReg(0);
	Op2Expr = NULL;
  }
#endif

#if (defined(__i386__) && defined(__GNUC__) && BX_SupportHostAsms)
  Bit32u flags32;

  asmTest32(op1_32, op2_32, flags32);
  setEFlagsOSZAPC(flags32);
#else
  Bit32u result_32;
  result_32 = op1_32 & op2_32;

  SET_FLAGS_OSZAPC_32_WITHEXPR(op1_32, op2_32, result_32, BX_INSTR_TEST32, Op1Expr, Op2Expr);
#endif
}


  void
BX_CPU_C::TEST_EdId(bxInstruction_c *i)
{
  Bit32u op2_32, op1_32;
  Bit8u op1_integrity, op2_integrity;
  Expression *Op1Expr, *Op2Expr;

  op2_32 = i->Id();
  op2_integrity = 0xFF;
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op2Expr = NULL;
  }
#endif

  if (i->modC0()) {
    op1_32 = BX_READ_32BIT_REG(i->rm());
    op1_integrity = BX_READ_32BIT_INTEGRITY(i->rm());
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	Op1Expr = (Expression *) MakeNewQuadReg(i->rm());
  }
#endif
    }
  else {
    read_virtual_dword(i->seg(), RMAddr(i), &op1_32, &op1_integrity);
#if BX_DEBUGGER
  if (BX_CPU_THIS_PTR sexecmode)
  {
  	MakeNewQuadMem(i->seg(), RMAddr(i), Op1Expr);
  }
#endif
    }

#if (defined(__i386__) && defined(__GNUC__) && BX_SupportHostAsms)
  Bit32u flags32;

  asmTest32(op1_32, op2_32, flags32);
  setEFlagsOSZAPC(flags32);
#else
  Bit32u result_32;
  result_32 = op1_32 & op2_32;

  SET_FLAGS_OSZAPC_32_WITHEXPR(op1_32, op2_32, result_32, BX_INSTR_TEST32, Op1Expr, Op2Expr);
#endif
}
